#version 430
#extension GL_ARB_separate_shader_objects : enable










struct SComputeInput
{
	uvec3 GlobalThreadID; uvec3 LocalThreadID; uvec3 GroupID;};

layout( std140) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 UserToLHZ;
	mat4 LHZToUser;
	mat4 BillboardingView;
	mat4 PackNormalView;
	mat4 UnpackNormalView;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	vec2 ViewportSize;
	float Handedness;
} SceneInfo;
layout(std430 ) readonly buffer BStreamInfo
{
	uint StreamInfo[];
} StreamInfo;
layout(std430 ) readonly buffer BGPUSimData
{
	uint GPUSimData[];
} GPUSimData;
layout(std430 ) readonly buffer BPositionsOffsets
{
	uint PositionsOffsets[];
} PositionsOffsets;
layout(std430 ) buffer BOutSortKeys
{
	uint OutSortKeys[];
} OutSortKeys;
layout(std430 ) buffer BOutIndirection
{
	uint OutIndirection[];
} OutIndirection;

layout( std140) uniform UInfo
{
	uint DrawRequest;
} Info;



void ComputeMain( in SComputeInput  cInput  )
{
	uint particleID = cInput.GlobalThreadID.x;
	const uint drawRequest =  Info.DrawRequest ;
	const vec3 viewPos =  SceneInfo.BillboardingView [3] .xyz;
	const uint positionsOffset =  PositionsOffsets.PositionsOffsets [ (drawRequest) ] ;
	const vec3 pos =  vec3( uintBitsToFloat(GPUSimData.GPUSimData [positionsOffset + (particleID * 3) ]) , uintBitsToFloat(GPUSimData.GPUSimData [(positionsOffset + (particleID * 3) ) + 1]) , uintBitsToFloat(GPUSimData.GPUSimData [(positionsOffset + (particleID * 3) ) + 2]) ) ;
	const vec3 delta = pos - viewPos;
	const float distSquared = delta.x * delta.x + delta.y * delta.y + delta.z * delta.z;
	uint key = ~ floatBitsToUint( packHalf2x16(vec2 (distSquared, 0)) ) ;
	if (particleID >=  StreamInfo.StreamInfo [0] )
		key = ~uint(0);

	OutSortKeys.OutSortKeys [ (particleID) ] = key; ;

	OutIndirection.OutIndirection [ (particleID) ] = particleID; ;
}

layout(local_size_x = 128, local_size_y = 1, local_size_z = 1) in;
void main()
{
	SComputeInput cInput;
	cInput.GlobalThreadID = gl_GlobalInvocationID;
	cInput.LocalThreadID = gl_LocalInvocationID;
	cInput.GroupID = gl_WorkGroupID;
	ComputeMain(cInput);
}
